#include <windows.h>
#include <gl\gl.h>
#include <gl\glu.h>
#include <gl\glaux.h>
//#include <math.h>

extern bool	keys[256];			// pole - prca s klavesnicou

float frame=0.0f;				//premenna na pocitanie snimkov

void DrawGLScene(void)				// vlastn kreslenie
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	//cisti buffer v aktualnom viewporte a to iba color a hlbkovy bit
	glLoadIdentity();					//Nahradi aktualnu maticu z identicku maticu
	glTranslatef(0.0f,0.0f,-5.0f);	//nasoby aktualnu maticu z transformacnou maticou - posunie pociatok
	
	// ked sa stlaci p zmeni sa polygon mod tak, ze sa budu kreslit zaklande primitivy ohranicene ciaramy
	if(keys['P'])glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);
	else glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);		// ked nie je stalecene p vykresluju sa plne primitivy

	glColor3f(1.0f,1.0f,1.0f);		//biela farba	
	/*Kreslime body*/
	glBegin(GL_POINTS);			//kreslme body
		glVertex3f(-2.0f,2.0f,0.0f);	//zadavame suradnice bodu x,y,z
		glVertex3f(-2.1f,2.0f,0.0f);
		glVertex3f(-2.2f,2.0f,0.0f);
	glEnd();					//koniec kreslenia bodov

	glBegin(GL_LINES);			//kreslme ciary
		glVertex3f(-1.8f,2.0f,0.0f);
		glVertex3f(-1.5f,1.5f,0.0f);

		glVertex3f(-1.3f,2.0f,0.0f);
		glVertex3f(-1.7f,1.4f,0.0f);

		glVertex3f(-1.4f,2.0f,0.0f);
		glVertex3f(-1.4f,1.3f,0.0f);
	glEnd();

	glBegin(GL_LINE_STRIP);		//kreslme lomenu ciaru
		glVertex3f(-1.0f,2.0f,0.0f);
		glVertex3f(-0.8f,1.5f,0.0f);
		glVertex3f(-0.5f,2.0f,0.0f);
		glVertex3f(-1.1f,1.8f,0.0f);
		glVertex3f(-0.8f,1.3f,0.0f);
	glEnd();

	glBegin(GL_POLYGON);		//kreslme mnohouholnk
		glVertex3f(0.0f,2.0f,0.0f);
		glVertex3f(0.5f,1.8f,0.0f);
		glVertex3f(0.8f,1.2f,0.0f);
		glVertex3f(0.5f,1.7f,0.0f);
		glVertex3f(0.0f,1.3f,0.0f);
		glVertex3f(-0.2f,1.5f,0.0f);
	glEnd();

	glBegin(GL_QUADS);			//kreslme samostatn tvoruholnky
		glVertex3f(1.0f,2.0f,0.0f);
		glVertex3f(1.4f,1.8f,0.0f);
		glVertex3f(1.3f,1.0f,0.0f);
		glVertex3f(1.1f,1.2f,0.0f);
		
		glColor3f(0.8f,0.0f,0.5f);
	
		glVertex3f(1.5f,2.0f,0.0f);
		glVertex3f(1.9f,1.8f,0.0f);
		glVertex3f(1.8f,1.0f,0.0f);
		glVertex3f(1.6f,1.2f,0.0f);
	glEnd();

	glColor3f(1.0f,1.0f,1.0f);
	glBegin(GL_TRIANGLES);		//kreslme trojuholnky
		glVertex3f(-1.8f,0.5f,0.0f);
		glVertex3f(-2.0f,-0.4f,0.0f);
		glVertex3f(-1.5f,-0.2f,0.0f);

		glColor3f(0.2f,0.0f,0.9f);
		glVertex3f(-2.0f,-0.2f,0.0f);
		glVertex3f(-2.3f,0.5f,0.0f);
		glVertex3f(-2.5f,-0.4f,0.0f);

		glColor3f(1.0f,0.0f,0.0f);		//farebn trojuholk
		glVertex3f(-1.4f,0.5f,0.0f);
		glColor3f(0.0f,1.0f,0.0f);		//zelen
		glVertex3f(-1.5f,-0.4f,0.0f);
		glColor3f(0.0f,0.0f,1.0f);		//modr
		glVertex3f(-1.1f,0.2f,0.0f);
	glEnd();

	glBegin(GL_TRIANGLE_STRIP);			//kreslme pruh trojuholnkov
		glColor3f(0.1f,0.0f,0.0f);
		glVertex3f(-1.0f,-1.0f,0.0f);
		
		glColor3f(0.5f,0.0f,0.0f);
		glVertex3f(-0.7f,0.0f,0.0f);
		
		glColor3f(0.5f,0.5f,0.0f);
		glVertex3f(-0.4f,-0.8f,0.0f);
		
		glColor3f(0.5f,0.5f,0.5f);
		glVertex3f(-0.3f,-0.3f,0.0f);
		
		glColor3f(1.0f,0.5f,0.5f);
		glVertex3f(0.0f,-1.3f,0.0f);
		
		glColor3f(1.0f,1.0f,0.0f);
		glVertex3f(0.3f,0.1f,0.0f);
		
		glColor3f(1.0f,1.0f,1.0f);
		glVertex3f(0.5f,-1.0f,0.0f);
	glEnd();

	glBegin(GL_TRIANGLE_FAN);		//kreslme vejr trojuholnkov
		glColor3f(1.0f,1.0f,1.0f);
		glVertex3f(1.5f,0.0f,0.0f);

		glColor3f(1.0f,0.0f,0.0f);
		glVertex3f(0.5f,0.0f,0.0f);

		glColor3f(0.0f,1.0f,0.0f);
		glVertex3f(0.8f,0.9f,0.0f);

		glColor3f(0.0f,0.0f,1.0f);
		glVertex3f(1.3f,0.5f,0.0f);

		glColor3f(0.3f,0.3f,0.3f);
		glVertex3f(1.8f,0.7f,0.0f);

		glColor3f(0.6f,0.6f,0.6f);
		glVertex3f(2.3f,0.5f,0.0f);
		
		glColor3f(0.9f,0.9f,0.9f);
		glVertex3f(2.5f,0.2f,0.0f);
		
		glColor3f(1.0f,1.0f,1.0f);
		glVertex3f(1.8f,-0.2f,0.0f);
	glEnd();


	glTranslatef(2.3f,-1.5f,0.0f);		//posunieme suradnicovu sustavu do bodu 2.3,-1.5,0.0
	glRotatef(frame,0.0f,0.0f,1.0f);	//rotujeme okolo z vektora
	glBegin(GL_TRIANGLES);				//kreslme trojuholk
		glColor3f(1.0f,1.0f,1.0f);
	
		glVertex3f(-0.1f,-0.2f,0.0f);
		glVertex3f(0.1f,-0.2f,0.0f);
		glVertex3f(0.0f,0.0f,0.0f);

	glEnd();

	frame+=1.0f;						//zvysujeme frame - pocet vykreslenych snimkov do teraz

}